%define api 1.0
%define glibapi 2.0
%define major 0

Summary:	C++ bindings for GStreamer with a Qt-style API
Name:		qt-gstreamer
Version:	1.2.0
Release:	3
License:	LGPLv2+
Group:		System/Libraries
Url:		http://gstreamer.freedesktop.org/wiki/QtGStreamer
Source0:	http://gstreamer.freedesktop.org/src/qt-gstreamer/%{name}-%{version}.tar.xz
Patch0:		qt-gstreamer-1.2.0-pkgconfig.patch
# From Fedora's package
Patch10:	0001-gstqtvideosink-fix-memory-leak-and-synchronization-i.patch
Patch11:	0002-CMakeLists.txt-actually-require-GStreamer-1.2.0.patch
Patch12:	0003-qtglvideosinkbase-don-t-use-variable-name-interface-.patch
Patch13:	0004-Add-pbutils-include-directory-to-include-paths.patch
Patch14:	0005-Workaround-build-failures-with-boost-1.57-and-moc.patch
Patch15:	0006-Fix-compilation-with-GStreamer-1.5.1.patch
Patch16:	qt-gstreamer-1.2.0-boost_160.patch
BuildRequires:	bison
BuildRequires:	cmake
BuildRequires:	doxygen
BuildRequires:	flex
BuildRequires:	qt4-qmlviewer
BuildRequires:	boost-devel
BuildRequires:	qt4-devel
BuildRequires:	pkgconfig(glib-%{glibapi})
BuildRequires:	pkgconfig(gstreamer-%{api})
BuildRequires:	pkgconfig(gstreamer-app-%{api})
BuildRequires:	pkgconfig(gstreamer-audio-%{api})
BuildRequires:	pkgconfig(gstreamer-base-%{api})
BuildRequires:	pkgconfig(gstreamer-pbutils-%{api})
BuildRequires:	pkgconfig(gstreamer-plugins-base-%{api})
BuildRequires:	pkgconfig(gstreamer-video-%{api})
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5Declarative)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5OpenGL)
BuildRequires:	pkgconfig(Qt5Qml)
BuildRequires:	pkgconfig(Qt5Quick)
BuildRequires:	pkgconfig(Qt5Test)
BuildRequires:	pkgconfig(Qt5Widgets)

%description
QtGStreamer provides C++ bindings for GStreamer with a Qt-style API,
plus some helper classes for integrating GStreamer better in Qt 4
applications.

%files
%{_libdir}/gstreamer-%{api}/libgstqtvideosink.so
%{_qt_importdir}/QtGStreamer/

#----------------------------------------------------------------------------

%define libqtglib %mklibname QtGLib %{glibapi} %{major}

%package -n %{libqtglib}
Summary:	C++/Qt bindings for parts of the GLib and GObject APIs
Group:		System/Libraries
Conflicts:	%{_lib}qt-gstreamer0 < 0.10.2
Conflicts:	%{_lib}qtglib0.10.2 < 0.10.2-4
Obsoletes:	%{_lib}qtglib0.10.2 < 0.10.2-4
Conflicts:	%{_lib}qtglib2.0_0.10.2 < 0.10.2-4
Obsoletes:	%{_lib}qtglib2.0_0.10.2 < 0.10.2-4

%description -n %{libqtglib}
Library providing C++/Qt bindings for parts of the GLib and GObject
APIs, a base on which QtGStreamer is built.

%files -n %{libqtglib}
%{_libdir}/libQtGLib-%{glibapi}.so.%{major}
%{_libdir}/libQtGLib-%{glibapi}.so.%{version}

#----------------------------------------------------------------------------

%define libqtgstreamer %mklibname QtGStreamer %{api} %{major}

%package -n %{libqtgstreamer}
Summary:	C++/Qt bindings for GStreamer
Group:		System/Libraries

%description -n %{libqtgstreamer}
Library providing C++/Qt bindings for GStreamer

%files -n %{libqtgstreamer}
%{_libdir}/libQtGStreamer-%{api}.so.%{major}
%{_libdir}/libQtGStreamer-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define libqtgstreamerui %mklibname QtGStreamerUi %{api} %{major}

%package -n %{libqtgstreamerui}
Summary:	Library providing integration with QtGui
Group:		System/Libraries

%description -n %{libqtgstreamerui}
Library providing integration with QtGui.

%files -n %{libqtgstreamerui}
%{_libdir}/libQtGStreamerUi-%{api}.so.%{major}
%{_libdir}/libQtGStreamerUi-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define libqtgstreamerutils %mklibname QtGStreamerUtils %{api} %{major}

%package -n %{libqtgstreamerutils}
Summary:	Library providing some high level utility classes
Group:		System/Libraries

%description -n %{libqtgstreamerutils}
Library providing some high level utility classes.

%files -n %{libqtgstreamerutils}
%{_libdir}/libQtGStreamerUtils-%{api}.so.%{major}
%{_libdir}/libQtGStreamerUtils-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define devname %mklibname %{name} -d

%package -n %{devname}
Summary:	Development files for QtGstreamer
Group:		Development/KDE and Qt
Requires:	%{libqtglib} = %{EVRD}
Requires:	%{libqtgstreamer} = %{EVRD}
Requires:	%{libqtgstreamerui} = %{EVRD}
Requires:	%{libqtgstreamerutils} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
QtGStreamer provides C++ bindings for GStreamer with a Qt-style API,
plus some helper classes for integrating GStreamer better in Qt
applications.

This package contains files for developing applications using QtGstreamer.

%files -n %{devname}
%{_libdir}/libQtGLib-%{glibapi}.so
%{_libdir}/libQtGStreamer-%{api}.so
%{_libdir}/libQtGStreamerUi-%{api}.so
%{_libdir}/libQtGStreamerUtils-%{api}.so
%{_libdir}/pkgconfig/QtGLib-2.0.pc
%{_libdir}/pkgconfig/QtGStreamer-1.0.pc
%{_libdir}/pkgconfig/QtGStreamerUi-1.0.pc
%{_libdir}/pkgconfig/QtGStreamerUtils-1.0.pc
%{_libdir}/cmake/QtGStreamer/*.cmake
%{_includedir}/QtGStreamer

#----------------------------------------------------------------------------

%package -n qt5-gstreamer
Summary:	C++ bindings for GStreamer with a Qt-style API
Group:		System/Libraries

%description -n qt5-gstreamer
QtGStreamer provides C++ bindings for GStreamer with a Qt-style API,
plus some helper classes for integrating GStreamer better in Qt 5
applications.

%files -n qt5-gstreamer
%{_libdir}/gstreamer-%{api}/libgstqt5videosink.so
%{_qt5_importdir}/QtGStreamer/
%{_qt5_libdir}/qt5/qml/QtGStreamer/

#----------------------------------------------------------------------------

%define libqt5glib %mklibname Qt5GLib %{glibapi} %{major}

%package -n %{libqt5glib}
Summary:	C++/Qt bindings for parts of the GLib and GObject APIs
Group:		System/Libraries

%description -n %{libqt5glib}
Library providing C++/Qt bindings for parts of the GLib and GObject
APIs, a base on which QtGStreamer is built.

%files -n %{libqt5glib}
%{_libdir}/libQt5GLib-%{glibapi}.so.%{major}
%{_libdir}/libQt5GLib-%{glibapi}.so.%{version}

#----------------------------------------------------------------------------

%define libqt5gstreamer %mklibname Qt5GStreamer %{api} %{major}

%package -n %{libqt5gstreamer}
Summary:	C++/Qt bindings for GStreamer
Group:		System/Libraries

%description -n %{libqt5gstreamer}
Library providing C++/Qt bindings for GStreamer

%files -n %{libqt5gstreamer}
%{_libdir}/libQt5GStreamer-%{api}.so.%{major}
%{_libdir}/libQt5GStreamer-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define libqt5gstreamerquick %mklibname Qt5GStreamerQuick %{api} %{major}

%package -n %{libqt5gstreamerquick}
Summary:	C++/Qt bindings for GStreamer
Group:		System/Libraries

%description -n %{libqt5gstreamerquick}
Library providing C++/Qt bindings for GStreamer

%files -n %{libqt5gstreamerquick}
%{_libdir}/libQt5GStreamerQuick-%{api}.so.%{major}
%{_libdir}/libQt5GStreamerQuick-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define libqt5gstreamerui %mklibname Qt5GStreamerUi %{api} %{major}

%package -n %{libqt5gstreamerui}
Summary:	Library providing integration with QtGui
Group:		System/Libraries

%description -n %{libqt5gstreamerui}
Library providing integration with QtGui.

%files -n %{libqt5gstreamerui}
%{_libdir}/libQt5GStreamerUi-%{api}.so.%{major}
%{_libdir}/libQt5GStreamerUi-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define libqt5gstreamerutils %mklibname Qt5GStreamerUtils %{api} %{major}

%package -n %{libqt5gstreamerutils}
Summary:	Library providing some high level utility classes
Group:		System/Libraries

%description -n %{libqt5gstreamerutils}
Library providing some high level utility classes.

%files -n %{libqt5gstreamerutils}
%{_libdir}/libQt5GStreamerUtils-%{api}.so.%{major}
%{_libdir}/libQt5GStreamerUtils-%{api}.so.%{version}

#----------------------------------------------------------------------------

%define devname5 %mklibname qt5-gstreamer -d

%package -n %{devname5}
Summary:	Development files for Qt5Gstreamer
Group:		Development/KDE and Qt
Requires:	%{libqt5glib} = %{EVRD}
Requires:	%{libqt5gstreamer} = %{EVRD}
Requires:	%{libqt5gstreamerquick} = %{EVRD}
Requires:	%{libqt5gstreamerui} = %{EVRD}
Requires:	%{libqt5gstreamerutils} = %{EVRD}
Provides:	qt5-gstreamer-devel = %{EVRD}

%description -n %{devname5}
Qt5GStreamer provides C++ bindings for GStreamer with a Qt-style API,
plus some helper classes for integrating GStreamer better in Qt
applications.

This package contains files for developing applications using Qt5Gstreamer.

%files -n %{devname5}
%{_libdir}/libQt5GLib-%{glibapi}.so
%{_libdir}/libQt5GStreamer-%{api}.so
%{_libdir}/libQt5GStreamerQuick-%{api}.so
%{_libdir}/libQt5GStreamerUi-%{api}.so
%{_libdir}/libQt5GStreamerUtils-%{api}.so
%{_libdir}/pkgconfig/Qt5GLib-2.0.pc
%{_libdir}/pkgconfig/Qt5GStreamer-1.0.pc
%{_libdir}/pkgconfig/Qt5GStreamerQuick-1.0.pc
%{_libdir}/pkgconfig/Qt5GStreamerUi-1.0.pc
%{_libdir}/pkgconfig/Qt5GStreamerUtils-1.0.pc
%{_libdir}/cmake/Qt5GStreamer/*.cmake
%{_includedir}/Qt5GStreamer

#--------------------------------------------------------------------

%prep
%setup -q
%patch0 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1

mkdir Qt4
mv `ls -1 |grep -v Qt4` Qt4
cp -a Qt4 Qt5

%build
pushd Qt4
%cmake_qt4 \
	-DQT_VERSION=4 \
	-DQTGSTREAMER_TESTS=OFF \
	-DLIB_INSTALL_DIR=%{_libdir}
%make
popd

pushd Qt5
%cmake_qt5 \
	-DQT_VERSION=5 \
	-DQTGSTREAMER_TESTS=OFF \
	-DLIB_INSTALL_DIR=%{_libdir}
%make
popd

%install
%makeinstall_std -C Qt4/build

%makeinstall_std -C Qt5/build

%changelog

* Sun May 08 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.2.0-3
- (ada1264) Add patches from Fedora to fix build with GStreamer 1.6 and boost 1.60


